/*
 * JPA entity template
 *
 *
 * Takatuka - Template fuer JPA2 Entitaeten (inklusive Bean Validation)
 *
 * Moeglichkeiten und Einschraenkungen:
 * - Beziehungen werden abgebildet
 * -- es gibt keine 1:1 Beziehungen
 * -- N:M Beziehungen sind immer bidirektional
 * - Vererbung wird nicht unterstuetzt
 * - Support für CustomData
 */
package de.ivu.elect.business.person.entity;

@javax.persistence.NamedQueries(
 {



       @javax.persistence.NamedQuery(
     name="KREDITINSTITUT.UK",
     query="SELECT o FROM Kreditinstitut o WHERE "

                         + "o"
                +".bankleitzahl"
              +" = ?1"

     ,
   hints = {
              @javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
             @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
   }


   )
   
     ,   @javax.persistence.NamedQuery(
     name="KREDITINSTITUT.All",
     query="SELECT o FROM Kreditinstitut o",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
     }
)
@javax.enterprise.inject.Vetoed
@javax.persistence.Entity
@javax.persistence.Table(name = "KREDITINSTITUT")
// @javax.persistence.IdClass(KreditinstitutPK.class)
    @javax.persistence.EntityListeners(de.ivu.elect.jee.protokollierung.ProtokollEntityListener.class)
    @javax.persistence.Cacheable

public
 class Kreditinstitut
extends AbstractKreditinstitut
  {

  private static final long serialVersionUID = 0L;


  /**
   * default constructor
   */
  public Kreditinstitut() {
    super();
  }

    /**
     * @param original
     *
     * @deprecated Sollte nur mit Bedacht genutzt werden, da hier auch die Beziehungen kopiert werden. Deswegen markiert
     *             als Deprecated.
     */
    @Deprecated
    public Kreditinstitut(Kreditinstitut original){
      original.copyEntity(this);
    }

  /**
   * PRIMARY KEY
   */
  @javax.persistence.Id
  @javax.persistence.Column(name = "kreditinstitut_id")
    @javax.persistence.GeneratedValue(strategy = javax.persistence.GenerationType.TABLE, generator = "Kreditinstitut")
    @javax.persistence.TableGenerator(name = "Kreditinstitut", table = "SEQUENCES", pkColumnName = "sequence_name", pkColumnValue = "Kreditinstitut", valueColumnName = "next_val", allocationSize = 1000, initialValue = 0)
    protected java.lang.Long id;

  @Override
  public java.lang.Long getId() {
    return id;
  }

  public void setId(java.lang.Long id) {
    this.id = id;
  }

  @javax.persistence.Transient
  private transient KreditinstitutPK pkCache;

  @Override
  public KreditinstitutPK getPk() {
    if (pkCache==null || pkCache.getId() != id ) {
      pkCache = new KreditinstitutPK(getId());
    }

    return pkCache;
  }

  public static <E extends Kreditinstitut> java.util.Map<KreditinstitutPK, E> mappeNachPk(java.util.Collection<E> entities){
    java.util.Map<KreditinstitutPK, E> result = new java.util.HashMap<>();

    for (E entity : entities) {
      result.put(entity.getPk(), entity);
    }

    return result;
  }

  public static <E extends Kreditinstitut> java.util.Map<Long, E> mappeNachId(java.util.Collection<E> entities){
    java.util.Map<Long, E> result = new java.util.HashMap<>();

    for (E entity : entities) {
      result.put(entity.getId(), entity);
    }

    return result;
  }



  /**
   * Indikator, ob sich ein Attribut oder eine UNIDIREKTIONALE n:1-Beziehungen geaendert hat
   */
  @javax.persistence.Transient
  protected boolean attributeChanged = false;

  public void setAttributeChanged() {
    attributeChanged = true;
  }

  public boolean isAttributeChanged() {
    return attributeChanged;
  }

  /**
   * Hilfsvariable fuer das Aktualisieren von Beziehungen
   */
  @javax.persistence.Transient
  protected boolean updateRelationship = false;



  public void resetAttributeChanged() {
        hasChangedBankleitzahl = false;
          hasChangedBezeichnung = false;
          hasChangedBic = false;
  



    attributeChanged = false;
  }


  /**
   * ATTRIBUTE
   */

    
      @javax.persistence.Column(name = "BANKLEITZAHL", nullable = KreditinstitutConstants.BANKLEITZAHL_NULLABLE, length=KreditinstitutConstants.BANKLEITZAHL_MAX_LENGTH)
        
  protected java.lang.String bankleitzahl =  null;

  @javax.persistence.Transient
  protected boolean hasChangedBankleitzahl = false;

  public boolean hasChangedBankleitzahl(){
    return hasChangedBankleitzahl;
  }
  
  /**
   * 
   *
   * getter for KREDITINSTITUT.BANKLEITZAHL
   */
    @Override   public  java.lang.String getBankleitzahl() {
        return bankleitzahl;
      }

  /**
   * 
   *
   * setter for KREDITINSTITUT.BANKLEITZAHL
   *
   * @param bankleitzahl
   */
  @Override   public void setBankleitzahl( java.lang.String bankleitzahl) {

       resetTkCache();
                  
                          java.lang.String bankleitzahlInternal = de.ivu.elect.jee.entity.EntityUtil.trimToNullOrMaxLength(bankleitzahl, KreditinstitutConstants.BANKLEITZAHL_MAX_LENGTH, getId(), getClass());
                  
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.bankleitzahl
      , bankleitzahlInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedBankleitzahl |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("bankleitzahl");
      }


      

       this.bankleitzahl = bankleitzahlInternal;

         }

        
  @javax.persistence.Column(name = "BEZEICHNUNG", nullable = KreditinstitutConstants.BEZEICHNUNG_NULLABLE, length=KreditinstitutConstants.BEZEICHNUNG_MAX_LENGTH)
        
  protected java.lang.String bezeichnung =  null;

  @javax.persistence.Transient
  protected boolean hasChangedBezeichnung = false;

  public boolean hasChangedBezeichnung(){
    return hasChangedBezeichnung;
  }
  
  /**
   * 
   *
   * getter for KREDITINSTITUT.BEZEICHNUNG
   */
  @javax.annotation.Nullable   @Override   public  java.lang.String getBezeichnung() {
        return bezeichnung;
      }

  /**
   * 
   *
   * setter for KREDITINSTITUT.BEZEICHNUNG
   *
   * @param bezeichnung
   */
  @Override   public void setBezeichnung(@javax.annotation.Nullable  java.lang.String bezeichnung) {

       resetTkCache();
                  
                          java.lang.String bezeichnungInternal = de.ivu.elect.jee.entity.EntityUtil.trimToNullOrMaxLength(bezeichnung, KreditinstitutConstants.BEZEICHNUNG_MAX_LENGTH, getId(), getClass());
                  
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.bezeichnung
      , bezeichnungInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedBezeichnung |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("bezeichnung");
      }


      

       this.bezeichnung = bezeichnungInternal;

         }

        
  @javax.persistence.Column(name = "BIC", nullable = KreditinstitutConstants.BIC_NULLABLE, length=KreditinstitutConstants.BIC_MAX_LENGTH)
        
  protected java.lang.String bic =  null;

  @javax.persistence.Transient
  protected boolean hasChangedBic = false;

  public boolean hasChangedBic(){
    return hasChangedBic;
  }
  
  /**
   * 
   *
   * getter for KREDITINSTITUT.BIC
   */
  @javax.annotation.Nullable   @Override   public  java.lang.String getBic() {
        return bic;
      }

  /**
   * 
   *
   * setter for KREDITINSTITUT.BIC
   *
   * @param bic
   */
  @Override   public void setBic(@javax.annotation.Nullable  java.lang.String bic) {

       resetTkCache();
                  
                          java.lang.String bicInternal = de.ivu.elect.jee.entity.EntityUtil.trimToNullOrMaxLength(bic, KreditinstitutConstants.BIC_MAX_LENGTH, getId(), getClass());
                  
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.bic
      , bicInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedBic |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("bic");
      }


      

       this.bic = bicInternal;

         }

    
/**
 * Beziehungen N:1 unidirektional
 */

/**
 * Beziehungen N:1 bidirektional
 */

  /**
   * Beziehungen 1:N unidirektional (nicht unterstuetzt)
   */

  /**
   * Beziehungen 1:N bidirektional
   */

  /**
   * Beziehungen N:M bidirektional nicht selbstreferenzierend
   */


  /**
   * Beziehungen N:M bidirektional selbstreferenzierend
   */
  

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("Kreditinstitut:");
    sb.append(getId());
    sb.append(" (TK: ");
    try {
      sb.append(getTk());
    } catch (Exception e) {
      sb.append(e.getMessage());
    }
    sb.append(")");
    return sb.toString();
}



  /**
   * Kopiert alle Attribute (ausser PK und Version) und UNIDIREKTIONALE n:1-Beziehungen in uebergebene Entitaet.
   *
   * @param other
   *
   * @deprecated Sollte nur mit Bedacht genutzt werden, da hier auch die Beziehungen kopiert werden. Deswegen markiert
   *             als Deprecated.
   */
  @Deprecated
  protected void copyEntity(Kreditinstitut other){
                             other.bankleitzahl = this.bankleitzahl;
                                other.bezeichnung = this.bezeichnung;
                                other.bic = this.bic;
           
    if (this.transientContext != null && !this.transientContext.isEmpty()) {
      other.getTransientContext().putAll(this.transientContext);
    }
  }



    @Override
    public void copyEntityAttributesToOtherEntity(de.ivu.elect.jee.entity.Entity other) {
      if (other==null){
        return;
      }
      if (other.isInstanceOf(Kreditinstitut.class)){
        copyEntityAttributesUsingSetter((Kreditinstitut) other.castTo(Kreditinstitut.class).getEntity());
      } else {
        throw new IllegalArgumentException("Keine Instanz von Kreditinstitut: " + other);
      }
    }

  /**
  * Kopiert alle Attribute (ausser PK und Version)  in uebergebene Entitaet.
  *
  */
  public void copyEntityAttributesUsingSetter(Kreditinstitut other){
               other.setBankleitzahl(this.bankleitzahl);
                  other.setBezeichnung(this.bezeichnung);
                  other.setBic(this.bic);
           if (this.transientContext != null && !this.transientContext.isEmpty()) {
      other.getTransientContext().putAll(this.transientContext);
    }
  }


  /**
   * Kopiert alle veränderten Attribute (ausser PK, CustomData, wenn vorhanden und Version) in uebergebene Entitaet.
   *
   */
  public void copyChangedEntityAttributesUsingSetter(Kreditinstitut other){
                       if (hasChangedBankleitzahl) {
        other.setBankleitzahl(this.bankleitzahl);
      }
                             if (hasChangedBezeichnung) {
        other.setBezeichnung(this.bezeichnung);
      }
                             if (hasChangedBic) {
        other.setBic(this.bic);
      }
             }





    @javax.persistence.Transient
    private transient KreditinstitutTK tkCache;

    protected void resetTkCache() {
        tkCache = null;
    }

    public KreditinstitutTK getKreditinstitutTK(){
    if (tkCache==null) {
    tkCache = new KreditinstitutTK(

getBankleitzahl()


  );}
  return tkCache;
}
    @Override
    public de.ivu.elect.jee.entity.tk.EntityTK getTk() {
       return getKreditinstitutTK();
    }

  @Override
  public KreditinstitutUK getUk(){
    return getKreditinstitutUK();
  }

  @Override
  public Class< ? > getEntityClass() {
    return Kreditinstitut.class;
  }

public KreditinstitutUK getKreditinstitutUK(){

   return  new KreditinstitutUK(

getBankleitzahl()


  );
}

  @javax.persistence.Transient
  private transient KreditinstitutProperties properties;

  public KreditinstitutProperties getProperties(){
    if (properties == null) {
      properties = new KreditinstitutProperties(this);
    }
    return properties;
  }

  /**
   * @deprecated getProperties() verwenden.
   */
  @Deprecated
  public KreditinstitutProperties getKreditinstitutProperties(){
    return getProperties();
  }

  @Override
  public String getEntityTechnicalName() {
    return KreditinstitutConstants.MESSAGE_KEY_ENTITY_EINZAHL;
  }

  @Override
  public boolean isAenderungenProtokollieren(){
    
    return false;
  }


    @Override
   public void setProtokollierteAttributeMitWerten(java.util.Map<String, de.ivu.elect.jee.protokollierung.AttributWertVorher> werteVorher) {
                                 }

  @Override
  public java.util.Map<String, de.ivu.elect.jee.protokollierung.VorherNachherWert> getProtokollierteAttributeMitWerten() {
    java.util.Map<String,de.ivu.elect.jee.protokollierung.VorherNachherWert> result;
        result = createEmptyProtokollierteAttributeMitWertenMap();
                                                                        return result;
  }

  @Override
  public void resetProtokollierteAttribute() {
                                                               }

  @Override
  public  java.util.List<de.ivu.elect.jee.entity.EntityFachlichAbhaengigNode> getFachlichAbhaengigeEntitaeten(){
            java.util.List<de.ivu.elect.jee.entity.EntityFachlichAbhaengigNode> result = new java.util.ArrayList<>();
            return result;
  }

        
            protected String getInitialDiscriminator() {
              return "KREDITINSTITUT";
            }

            @Override
            public boolean isInstanceOf(Class<?> clazz) {
            return clazz.isInstance(this);
            }


            @Override
            public <E> de.ivu.elect.jee.entity.EntityContainer<E> castTo(Class<E> clazz) {
                return new de.ivu.elect.jee.entity.EntityContainer<>((E)this); // EntityContainer ist notwendig, da sonst von Hibernate die Entität wieder durch ihren Proxy ersetzt wird...
            }

  public boolean isPersistent() {
    return getId() != null;
  }


   private static final String BASE_CLASS_NAME = "Kreditinstitut";
   @Override
   public String getBaseClassName() {
     return BASE_CLASS_NAME;
   }


    @Override
    public boolean equals(Object obj) {
    if (obj == null) {
    return false;
    }

    if (this==obj) {
    return true;
    }


    if (id != null) {
      try {
        return id.longValue() == ((de.ivu.elect.jee.entity.Entity) obj).getId().longValue() && BASE_CLASS_NAME.equals(((de.ivu.elect.jee.entity.Entity) obj).getBaseClassName());
      } catch (Exception ignored) {
        // do nothing
        return false;
      }
    }
   return super.equals(obj);
    }

    @Override
    public int hashCode() {

      if (id==null){
        return super.hashCode();
      }
      return id.hashCode();
    }


                            @javax.persistence.Transient
                private transient java.util.Set
            <String> dirtyProperties = null;

                protected void markDirty(String property) {
            
          }

          public java.util.Set
      <String> getDirtyProperties() {
          if (dirtyProperties==null){
          dirtyProperties = new java.util.HashSet<>();
          }
          return dirtyProperties;
          }

          public void clearDirtyProperties(){
          dirtyProperties = null;
          }
          public boolean isHibernateDirty() {
            return dirtyProperties!=null;
          }

      
                public void resetValidation() {
        
    validationResult = null;
        }

        @javax.persistence.Transient
        private transient java.util.Set<de.ivu.elect.jee.entity.EntityConstraintViolation> validationResult;

                    public java.util.Set<de.ivu.elect.jee.entity.EntityConstraintViolation> validateEntity() {
            if (validationResult==null) {
               validationResult  = new java.util.HashSet<>();
                                                                   de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(bankleitzahl, this, KreditinstitutConstants.MESSAGE_KEY_BANKLEITZAHL_EINZAHL, validationResult);
                                                                          de.ivu.elect.jee.entity.EntityConstraintCheck.checkStringLength(KreditinstitutConstants.BANKLEITZAHL_MAX_LENGTH , 1 ,  bankleitzahl, this, KreditinstitutConstants.MESSAGE_KEY_BANKLEITZAHL_EINZAHL, validationResult);
                                                                                                   de.ivu.elect.jee.entity.EntityConstraintCheck.checkStringLength(KreditinstitutConstants.BEZEICHNUNG_MAX_LENGTH ,  bezeichnung, this, KreditinstitutConstants.MESSAGE_KEY_BEZEICHNUNG_EINZAHL, validationResult);
                                                                                                   de.ivu.elect.jee.entity.EntityConstraintCheck.checkStringLength(KreditinstitutConstants.BIC_MAX_LENGTH ,  bic, this, KreditinstitutConstants.MESSAGE_KEY_BIC_EINZAHL, validationResult);
                                    }
             return validationResult;
        }

            
        @javax.persistence.Transient
        protected transient java.util.Map<String, Object> transientContext;

        public java.util.Map<String, Object> getTransientContext() {
          if (transientContext == null) {
             transientContext = new java.util.HashMap<>();
          }
        return transientContext;

        }

              }
